/*
 ============================================================================
 Name		: SomeClass.h
 Author	  : 
 Version	 : 1.0
 Copyright   : Your copyright notice
 Description : CSomeClass declaration
 ============================================================================
 */

#ifndef SOMECLASS_H
#define SOMECLASS_H

// INCLUDES
#include <e32std.h>
#include <e32base.h>

#include <in_sock.h> // For RSocket
#include <BatteryInfo.h>
#include <WirelessSensor.h>

// CLASS DECLARATION

/**
 *  CSomeClass
 * 
 */
class CApplication : public CBase
	{
public:
	static CApplication* NewL(CConsoleBase* aConsole);
	static CApplication* NewLC(CConsoleBase* aConsole);
	~CApplication();

public:
	CConsoleBase* GetConsole();

	void StartMIDlet();
	void GetWirelessNetworks(RSocket socket);
	void GetWirelessNetworksTest(RSocket socket);
	void GetBatteryStatus(RSocket socket);

	// HUMAN READABLE
	void GetWirelessNetworksHumanReadable(TDes8* aBuffer);
	void GetBatteryStatusHumanReadable(TDes8* aBuffer);

private:

	/**
	 * Constructor for performing 1st stage construction
	 */
	CApplication();

	/**
	 * EPOC default constructor for performing 2nd stage construction
	 */
	void ConstructL(CConsoleBase* aConsole);

private:
	CConsoleBase* iConsole;
	CBatteryInfo* iBatteryInfo;
	CWirelessSensor* iWirelessSensor;
	
	};

#endif // SOMECLASS_H
