/*
 ============================================================================
 Name		: BatteryInfo.h
 Author	  : Philipp Heckel
 Version	 : 1.0
 Copyright   : GPL
 Description : CBatteryInfo declaration
 ============================================================================
 */

#ifndef BATTERYINFO_H
#define BATTERYINFO_H

#include <e32base.h>	// For CActive, link against: euser.lib
//#include <e32std.h>		// For RTimer, link against: euser.lib

#include <etel3rdparty.h> // Fro CTelephony, link against: etel3rdparty.lib

// FROM: http://wiki.forum.nokia.com/index.php/CS000983_-_Changing_asynchronous_method_to_synchronous

class CBatteryInfo : public CActive
	{
public:
	static CBatteryInfo* NewL();
	static CBatteryInfo* NewLC();
	~CBatteryInfo();

private:
	CBatteryInfo();
	void ConstructL();

private: // From CActive
	void RunL();
	void DoCancel();

private:
    CTelephony* iTelephony;
    CActiveSchedulerWait iSchedulerWait;
    CTelephony::TBatteryInfoV1 iBatteryInfo;	

public:
	CTelephony::TBatteryInfoV1 GetBatteryInfo();

	};

#endif // BATTERYINFO_H
