/*
 ============================================================================
 Name		: TCPDaemon.h
 Author	  : Philipp Heckel
 Version	 : 1.0
 Copyright   : GPL
 Description : CTCPDaemon declaration
 ============================================================================
 */

#ifndef TCPDAEMON_H
#define TCPDAEMON_H

// INCLUDES
#include <e32std.h>
#include <e32base.h>
#include <Application.h>

// CLASS DECLARATION

/**
 *  CTCPDaemon
 * 
 */
class CTCPDaemon : public CBase
	{
public:
	// Constructors and destructor

	/**
	 * Destructor.
	 */
	~CTCPDaemon();

	/**
	 * Two-phased constructor.
	 */
	static CTCPDaemon* NewL(CApplication* aApplication);

	/**
	 * Two-phased constructor.
	 */
	static CTCPDaemon* NewLC(CApplication* aApplication);
	
	void Listen();	

private:

	/**
	 * Constructor for performing 1st stage construction
	 */
	CTCPDaemon();

	/**
	 * EPOC default constructor for performing 2nd stage construction
	 */
	void ConstructL(CApplication* aApplication);

	/**
	 * PHILIPP: Start daemon + go into loop
	 */

	void ProcessList(TDes8* aBuffer);
	
	CApplication* iApplication;
	CConsoleBase* iConsole;
	
	};

#endif // TCPDAEMON_H
