/*
 ============================================================================
 Name		: WirelessNetwork.h
 Author	  : Philipp Heckel
 Version	 : 1.0
 Copyright   : GPL
 Description : CWirelessNetwork declaration
 ============================================================================
 */

#ifndef WIRELESSNETWORK_H
#define WIRELESSNETWORK_H

// INCLUDES
#include <e32std.h>
#include <e32base.h>
#include <e32des8.h>

#include <wlanmgmtcommon.h> // For TWlanBssid / TWlanSsid

// CLASS DECLARATION

/**
 *  CWirelessNetwork
 * 
 */
class CWirelessNetwork : public CBase
	{
public:
	static CWirelessNetwork* NewL();
	static CWirelessNetwork* NewLC();
	~CWirelessNetwork();

private:
	CWirelessNetwork();

	void ConstructL();

private:
	TWlanBssid iBSSID;
	TWlanSsid iSSID;
	TUint8 iSignalStrength;

public:
	void SetBSSID(TWlanBssid &BSSID);
	void SetSSID(TWlanSsid &SSID);
	void SetSignalStrength(TUint8 SignalStrength);
	
	TWlanBssid& GetBSSID();
	TWlanSsid& GetSSID();
	TUint8 GetSignalStrength();
	
	};
#endif // WIRELESSNETWORK_H
