/*
 ============================================================================
 Name		: WirelessSensor.h
 Author	  : Philipp Heckel
 Version	 : 1.0
 Copyright   : GPL
 Description : CWirelessSensor declaration
 ============================================================================
 */

#ifndef WIRELESSSENSOR_H
#define WIRELESSSENSOR_H

#include <e32base.h>	// For CActive, link against: euser.lib
//#include <e32std.h>		// For RTimer, link against: euser.lib

//#include <wlanscaninfo.h> // For CWlanScanInfo, link against: ?
#include <wlanmgmtclient.h>

#include <WirelessNetwork.h>

class CWirelessSensor : public CActive
	{
public:
	static CWirelessSensor* NewL();
	static CWirelessSensor* NewLC();
	~CWirelessSensor();

private:
	CWirelessSensor();
	void ConstructL();

private: // From CActive
	void RunL();
	void DoCancel();

private:
	CActiveSchedulerWait iSchedulerWait;
	CWlanMgmtClient* iWLANMgmtClient;
	
	TInt GetSSID(CWlanScanInfo *scanInfo, TDes8 &aSSID);
	
public:
	CArrayFixFlat<CWirelessNetwork>* GetWirelessNetworks();

	};

#endif // WIRELESSSENSOR_H
