/*
 ============================================================================
 Name		: SomeClass.cpp
 Author	  : 
 Version	 : 1.0
 Copyright   : Your copyright notice
 Description : CSomeClass implementation
 ============================================================================
 */

#include <e32cons.h>			// CConsoleBase

#include <etel3rdparty.h> // for CTelephony; link against etel3rdparty.lib

#include <apaid.h> // link against apparc.lib -- for TApaAppInfo (midlet starten)
#include <apacmdln.h> // link: apparc.lib -- for CApaCommandLine
#include <apgcli.h> // link: apparc.lib -- for RApaLsSession

#include <rconnmon.h> // for RConnectionMonitor -- link against econnmon.lib

#include <Application.h>

CApplication::CApplication()
	{
	// No implementation required
	}

CApplication::~CApplication()
	{
	}

CApplication* CApplication::NewLC(CConsoleBase* aConsole)
	{
	CApplication* self = new (ELeave) CApplication();
	CleanupStack::PushL(self);
	self->ConstructL(aConsole);
	return self;
	}

CApplication* CApplication::NewL(CConsoleBase* aConsole)
	{
	CApplication* self = CApplication::NewLC(aConsole);
	CleanupStack::Pop(); // self;
	return self;
	}

void CApplication::ConstructL(CConsoleBase* aConsole)
	{
		iConsole = aConsole;		
	    iBatteryInfo = CBatteryInfo::NewL();
	    //iWirelessSensor = CWirelessSensor::NewL();
	}

CConsoleBase* CApplication::GetConsole()
	{
		return iConsole;
	}

void CApplication::StartMIDlet()
	{

   // FROM: http://discussion.forum.nokia.com/forum/showpost.php?p=77236&postcount=12
   RApaLsSession appSession;

   if( appSession.Connect() == KErrNone && appSession.GetAllApps() == KErrNone )
	   {
	   TApaAppInfo appInfo;  // Location: APAID.H - Link against: apparc.lib
	   TInt result = KErrNone;
	   TInt handeled = 0;
	   TInt count = 0;
	   TBuf<256> appPath( _L("") );
	   TBuf<64> appName;
	   TUid appUID;

	   // Find the path to the midlets app file, that gets created
	   // when the midlet is installed
	   while( result != RApaLsSession::ENoMoreAppsInList )
		   {
			if( result == KErrNone )
				result = appSession.GetNextApp( appInfo );
			
			// GetNextApp ocasionally fails, hence the use of
			// handeled and count.
			if( result == KErrNone && count == handeled )
				{
				handeled++;
				count++;
				appName.Copy( appInfo.iCaption );
				
				iConsole->Printf(_L("app: "));
				iConsole->Printf(appName); 
				iConsole->Printf(_L("\n"));					
				
				if( appName.Compare( _L("BluetoothMIDlet") ) == 0 )
					{
					// Found the app we we're looking for.
					appPath.Copy( appInfo.iFullName );
					appUID = appInfo.iUid;
					result = RApaLsSession::ENoMoreAppsInList;
					iConsole->Printf(_L("FOUND-PATH: "));
					iConsole->Printf(appPath);
					iConsole->Printf(_L("\n"));						
					}
				}
			
			else if( result == RApaLsSession::EAppListInvalid )
				{
				// Something failed, so the session is restarted.
				count = 0;
				appSession.Close();
				if( appSession.Connect() == KErrNone &&
				appSession.GetAllApps() == KErrNone )
				result = KErrNone;
				}
			
			} // while
	   
	   /*
			CApaCommandLine * cmd=CApaCommandLine::NewL();
			cmd->SetLibraryNameL( appPath );
			cmd->SetCommandL(EApaCommandRun);

			// Start the midlet
			if( appSession.StartApp(*cmd) == KErrNotFound )
				ShowErrorDialog( _L("MIDLET not found") );
		*/

	   
	   // FROM http://wiki.forum.nokia.com/index.php/TSS000465_-_Launching_MIDlets_programmatically_on_S60_3rd_Edition
			 TThreadId threadId;
			appSession.StartDocument(_L(""), appUID, threadId);

		   //An empty descriptor can be passed as the first parameter (document name).
		   //If the launching application wishes to monitor the MIDlet and receive a notification
			//when it is closed, it can be done by deriving from CActive and calling RThread::Logon():
			   /*TInt ret = iLaunchThread.Open(threadId); // iLaunchThread is of type RThread
			   if(ret == KErrNone)
				   {
				   iLaunchThread.Logon(iStatus);
				   SetActive();
				   }		   */
		} // if connect
   
		else
			{
			//ShowErrorDialog( _L("Failed to search for MIDLET") );
		iConsole->Write( _L("Failed to search for MIDLET") );
			}
   
		appSession.Close();
			
	}	

/**
 * TODO retrieve ssid + bssid
 *      auslagern in eine klasse
 *      waitforrequest durch activeschedulerwait ersetzen
 *      retrieve gsm cells and signal strenghts
 *      retrieve caller number
 *      	http://wiki.forum.nokia.com/index.php/TSS000685_-_Retrieving_incoming_and_outgoing_call_numbers
 *      	http://wiki.forum.nokia.com/index.php/How_to_handle_call_events_using_CTelephony_3rd_Edition
 */
void CApplication::GetWirelessNetworksHumanReadable(TDes8* aBuffer) 
	{
	iConsole->Printf(_L("CApplication::GetWirelessNetworks ...\n"));
			
    _LIT(KNetInfo, "Network: %S\tSignal: %d\n");
    TBuf<32> netName;
    TBuf<100> line;
    RConnectionMonitor monitor;
    TPckgBuf<TConnMonNetworkNames> pkgNetworks;
    // establish connection with the monitor server
    monitor.ConnectL();
    // prepare leave clean-up
    CleanupClosePushL(monitor);
    TRequestStatus status;
    // get the list of available networks
    monitor.GetPckgAttribute(EBearerIdWLAN, 0, KNetworkNames, pkgNetworks, status);
    // suspend thread until the info is retrieved
    // production code should use active objects
    User::WaitForRequest( status ) ;
    // leave if the asynchronous method returned an error
    User::LeaveIfError(status.Int());
    //  reset networks list
    //aNetworks.Reset();
    // add retrieved networks to the list
    for(TUint i=0; i<pkgNetworks().iCount; i++)
    {
        netName.Copy(pkgNetworks().iNetwork[i].iName);
        line.Format(KNetInfo, &netName, pkgNetworks().iNetwork[i].iSignalStrength);
        //aNetworks.AppendL(line);
        aBuffer->Append(line);
        iConsole->Printf(line);
    }
    // close server session
    CleanupStack::PopAndDestroy(&monitor);
    
	
	}

/**
 * Writes wireless network information, i.e., the SSID, BSSID
 * and the signal strength to the given socket.
 * 
 * Protocol:
 * [byte COUNT]
 *   <repeat COUNT times>
 *     [6 bytes BSSID]
 *     [32 bytes SSID]
 *     [1 byte SIGNAL]
 *   </repeat>
 * 
 * NOTE: In order to make the WLAN Info API work on a phone, the
 * .sisx-file needs to be signed by symbiansigned.com. Additionally,
 * the following capabilities (cmp. .mmp-file) are required:
 * 
 *    ReadUserData, WriteUserData, ReadDeviceData, NetworkServices
 */
void CApplication::GetWirelessNetworks(RSocket socket)
	{
	//iConsole->Printf(_L("CApplication::GetWirelessNetworks ...\n"));
	
	// Retrieve wifi info 
	CWirelessSensor* wifiSensor = CWirelessSensor::NewL();
	CArrayFixFlat<CWirelessNetwork>* networks = wifiSensor->GetWirelessNetworks();

	/*CWirelessNetwork* A = CWirelessNetwork::NewL();
	
	TUint8 bssid[6] = {0x00,0x19,0xcb,0x86,0x7e,0x2e}; // 00:19:CB:86:7E:2E
	TUint8 ssid[32] = {0x50,0x68,0x69,0x4c,0x65,0x4d,0x69,0x6b,0x61}; // PhiLeMiKa
	
	TBuf8<6> bssid2; bssid2.Copy(bssid, sizeof(bssid));
	TBuf8<32> ssid2; ssid2.Copy(ssid, sizeof(ssid));
	
	A->SetBSSID(bssid2);
	A->SetSSID(ssid2);
	A->SetSignalStrength(51);
	
	networks->AppendL(*A);*/
	
	TUint8 wifiCount = networks->Count();
	TUint8 itemSize = KWlanMaxBssidLength+KWlanMaxSsidLength+1; // 6 + 32 + 1 = 39
	
	TBuf8<256> buf;
	buf.Append(wifiCount);
	
	if (wifiCount == 0)
		iConsole->Write(_L(" -> None found.\n"));
	
	for(TUint8 i = 0; i<wifiCount; i++)
		{
		CWirelessNetwork* wlan = &(networks->At(i));

		TWlanBssid bssid = wlan->GetBSSID();
		TWlanSsid ssid = wlan->GetSSID();
		TUint8 rxLevel = wlan->GetSignalStrength();
		
		// Write to console
		iConsole->Write(_L(" - "));
		
		for(TUint8 j = 0; j<ssid.Length(); j++)
			iConsole->Printf(_L("%c"), ssid[j]);	
		
		iConsole->Write(_L(", "));
		
		for(TUint8 j = 0; j<bssid.Length(); j++)
			iConsole->Printf(_L("%02X"), bssid[j]);	
		
		iConsole->Printf(_L(", rx=%d\n"), rxLevel);
		
		// Write to buffer		
		bssid.SetLength(KWlanMaxBssidLength);  // Always send 6 bytes
		ssid.SetLength(KWlanMaxSsidLength);    // Always send 32 bytes
		
		buf.Append(bssid);
		buf.Append(ssid);
		buf.Append(rxLevel);
		
		// If buffer full or last round, write to socket
		if ((buf.Length()+itemSize > buf.MaxLength()) || (i == wifiCount-1)) 
			{
			// Write to console
			iConsole->Write(_L("<RAW>"));
			
			for(TUint8 j = 0; j<buf.Length(); j++)
				iConsole->Printf(_L("%02X "), buf[j]);	
			
			iConsole->Write(_L("</RAW>\n\n"));
			
			// Write to socket 
			TRequestStatus status;
			socket.Write(buf, status);
			User::WaitForRequest(status);
			
			// Reset buffer
			buf.SetLength(0);
			}
		}	
	}

/**
 * [byte COUNT]
 *   <repeat COUNT times>
 *     [6 bytes BSSID]
 *     [32 bytes SSID]
 *     [1 byte SIGNAL]
 *   </repeat>
 */
void CApplication::GetWirelessNetworksTest(RSocket socket)
	{
	iConsole->Printf(_L("CApplication::GetWirelessNetworksTest ...\n"));
	
	/** WLAN: getting all the information from the packages 
	 * http://discussion.forum.nokia.com/forum/showthread.php?t=126428 **/
	
	TUint8 wifiCount = 2;	
	TUint8 itemSize = KWlanMaxBssidLength+KWlanMaxSsidLength+1; // 6 + 32 + 1 = 39
	
	TBuf8<256> buf;
	buf.Append(wifiCount);
	
	for(TUint8 i = 0; i<wifiCount; i++)
		{
		TUint8 bssid[KWlanMaxBssidLength] = {0x00,0x19,0xcb,0x86,0x7e,0x2e}; // 00:19:CB:86:7E:2E
		TUint8 ssid[KWlanMaxSsidLength] = {0x50,0x68,0x69,0x4c,0x65,0x4d,0x69,0x6b,0x61}; // PhiLeMiKa
		TUint8 rxLevel = 51;
		
		buf.Append(bssid,KWlanMaxBssidLength);
		buf.Append(ssid,KWlanMaxSsidLength);
		buf.Append(rxLevel);
		
		// Buffer full or last round
		if ((buf.Length()+itemSize > buf.MaxLength()) || (i == wifiCount-1)) 
			{
			// Write to console
			for(TUint8 j = 0; j<buf.Length(); j++)
				iConsole->Printf(_L("%02X "), buf[j]);		
			
			// Write to socket 
			TRequestStatus status;
			socket.Write(buf, status);
			User::WaitForRequest(status);
			
			// Reset buffer
			buf.SetLength(0);
			}
		}	
	}


void CApplication::GetBatteryStatusHumanReadable(TDes8* aBuffer) 
	{
	iConsole->Printf(_L("CApplication::GetBatteryStatus ...\n"));
	
	// Retrieve from CBatteryInfo (via CActiveSchedulerWait)
	CTelephony::TBatteryInfoV1 batteryInfoV1 = iBatteryInfo->GetBatteryInfo();
	
	TUint8 batteryStatus;
	TBuf<100> batteryStatusStr;
	
	switch (batteryInfoV1.iStatus)
		{
		case CTelephony::EPoweredByBattery: 
			batteryStatus = 1; batteryStatusStr.Format(_L("EPoweredByBattery")); break;

		case CTelephony::EBatteryConnectedButExternallyPowered: 
			batteryStatus = 2; batteryStatusStr.Format(_L("EBatteryConnectedButExternallyPowered")); break;
		
		case CTelephony::ENoBatteryConnected: 
			batteryStatus = 3; batteryStatusStr.Format(_L("ENoBatteryConnected")); break;		

		case CTelephony::EPowerFault: 
			batteryStatus = 4; batteryStatusStr.Format(_L("EPowerFault")); break;
			
		case CTelephony::EPowerStatusUnknown: default:
			batteryStatus = 0; batteryStatusStr.Format(_L("EPowerStatusUnknown")); break;
		}
	
	TBuf<100> line;
	line.Format(_L("ChargeLevel: %d, Status: %d / %S\n"), batteryInfoV1.iChargeLevel, batteryStatus, &batteryStatusStr);
	
	aBuffer->Append(line);
	iConsole->Printf(line);
	}

/**
 * [byte CHARGE LEVEL PERCENTAGE]
 * [byte BATTERY STATUS CODE
 * 		0 = EPowerStatusUnknown
 * 		1 = EPoweredByBattery
 * 		2 = EBatteryConnectedButExternallyPowered
 * 		3 = ENoBatteryConnected
 * 		4 = EPowerFault
 * ]
 */
void CApplication::GetBatteryStatus(RSocket socket) 
	{
	//iConsole->Printf(_L("CApplication::GetBatteryStatus ...\n"));
	
	// Retrieve from CBatteryInfo (via CActiveSchedulerWait)
	CTelephony::TBatteryInfoV1 batteryInfoV1 = iBatteryInfo->GetBatteryInfo();
	
	TUint8 batteryStatus;
	TBuf<100> batteryStatusStr;
	
	switch (batteryInfoV1.iStatus)
		{
		case CTelephony::EPoweredByBattery: 
			batteryStatus = 1; batteryStatusStr.Format(_L("EPoweredByBattery")); break;

		case CTelephony::EBatteryConnectedButExternallyPowered: 
			batteryStatus = 2; batteryStatusStr.Format(_L("EBatteryConnectedButExternallyPowered")); break;
		
		case CTelephony::ENoBatteryConnected: 
			batteryStatus = 3; batteryStatusStr.Format(_L("ENoBatteryConnected")); break;		

		case CTelephony::EPowerFault: 
			batteryStatus = 4; batteryStatusStr.Format(_L("EPowerFault")); break;
			
		case CTelephony::EPowerStatusUnknown: default:
			batteryStatus = 0; batteryStatusStr.Format(_L("EPowerStatusUnknown")); break;
		}
	
	TBuf<100> line;
	line.Format(_L(" - ChargeLevel: %d\n - Status: %d / %S\n"), batteryInfoV1.iChargeLevel, batteryStatus, &batteryStatusStr);
	iConsole->Printf(line);	
	
	// Send info 
	TBuf8<2> response;
	
	response.Append((TUint8) batteryInfoV1.iChargeLevel);
	response.Append(batteryStatus);
	
	TRequestStatus status;
	socket.Write(response, status);
	User::WaitForRequest(status);

	// Write to console
	iConsole->Write(_L("<RAW>"));

	for(TUint8 j = 0; j<response.Length(); j++)
		iConsole->Printf(_L("%02X "), response[j]);
	
	iConsole->Write(_L("</RAW>\n\n"));
	
	}
